Attribute VB_Name = "mParse"
Private Const ID_EMOTE = &H17
#Const debugging = True
Private Const ID_WHISPTO = &HA
Private Const ID_WHISPFROM = &H4
Private Const ID_TALK = &H5
Private Const ID_USER = &H1
Private Const ID_JOIN = &H2
Private Const ID_LEAVE = &H3
Private Const ID_FLAGS = &H9
Private Const ID_CHAN = &H7
Private Const ID_ERROR = &H13
Private Const ID_INFO = &H12

Public Enum FormatLookupType
    Window = 1
    TextBox = 2
    Tag = 3
End Enum

Public LastSeen As String
Public lastChan As String
Public strProfLUser As String
Public lUsers As Integer
Public ChanVar As String
Public ProfVar As Integer
Public ProfUsrVar As String

Function MakeLong(x As String) As Long
    If Len(x) < 4 Then
        Exit Function
    End If
    CopyMemory MakeLong, ByVal x, 4
End Function
Public Sub strcpy(ByRef Source As String, ByVal nText As String)
    Source = Source & nText
End Sub

Public Function KillNull(ByVal text As String) As String
    Dim i As Integer
    i = InStr(1, text, Chr(0))
    If i = 0 Then
        KillNull = text
        Exit Function
    End If
    KillNull = Left(text, i - 1)
End Function

Public Sub GetValues(ByVal DataBuf As String, ByRef Ping As Long, ByRef Flags As Long, ByRef Name As String, ByRef Txt As String)
    Dim a As Long, b As Long, c As Long, D As Long, E As Long, F As Long, recvbufpos As Long
    Name = ""
    Txt = ""
    recvbufpos = 5
    F = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    a = CVL(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    b = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    c = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    D = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    E = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    Flags = a
    Ping = b
    Call strcpy(Name, KillNull(Mid$(DataBuf, 29)))
    Call strcpy(Txt, KillNull(Mid$(DataBuf, Len(Name) + 30)))
End Sub



Public Sub ParseBinary(strData As String)
Dim usrFlags&, Ping&, usrName$, usrText$
    
    

    
If Len(strData) < 4 Then Exit Sub
    GetValues strData, Ping, usrFlags, usrName, usrText
        
If msProduct = "D2DV" Then
    Dim spt() As String
    spt() = Split(usrName, "*", 2)
    If UBound(spt()) <= 0 Then
        usrName = usrName
    Else
        spt(0) = "*" & spt(0)
        usrName = "*" & spt(1)
    End If
End If
        Select Case Asc(Mid(strData, 5, 1))
            Case ID_WHISPFROM: Event_RecvWhisper usrName, usrFlags, usrText
            Case ID_TALK: Event_Talk usrName, usrFlags, usrText, Ping
            Case ID_EMOTE: Event_Emote usrName, usrFlags, usrText
            Case ID_JOIN: Event_Join usrName, usrFlags, usrText, Ping
            Case ID_USER: Event_User usrName, usrFlags, usrText, Ping
            Case ID_FLAGS: Event_Flags usrName, usrFlags, usrText, Ping
            Case ID_ERROR: Event_Error usrText
            Case ID_WHISPTO: Event_SendWhisper usrName, usrFlags, usrText, Ping
            Case ID_CHAN: Event_Channel usrName, usrText, Ping
            Case ID_INFO: Event_Info usrText
            Case ID_LEAVE: Event_Leave usrName, usrFlags
            Case Else: Event_Unknown strData
        End Select
End Sub

Public Sub Event_Emote(User As String, Flags As Long, text As String)
    
    AddChat RGB(255, 255, 1), " *" & User & " " & text & "*"
End Sub

Private Sub Event_Unknown(strText As String)

    Select Case strText
        Case " "
            Exit Sub
            
            addText strText & vbNewLine, RGB(150, 150, 150)
    End Select
End Sub

Private Sub Event_User(strUser As String, StrFlag, strText, Ping)
Dim PingCode As Integer

Log strUser & " is in the channel with " & Ping & " Ping"
PingCode = GetLagIcon(Ping, StrFlag)
Dim Icon As Integer
Icon = GetIconCode(strText, StrFlag)
If Icon = ICON_GAVEL Then
    frmMain.RoomList.ListItems.add 1, , strUser, , Icon
Else
    frmMain.RoomList.ListItems.add , , strUser, , Icon
End If
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , , PingCode
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ForeColor = vbWhite
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , Ping
Select Case ReverseString(Mid(strText, 1, 4))
    Case "DRTL"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Diablo Retail" & vbCrLf & _
                                "Level: " & lvl & vbCrLf & _
                                "Class: " & getClass(Val(chrClass)) & vbCrLf & _
                                "Dots: " & dots & vbCrLf & _
                                "Strength: " & strength & vbCrLf & _
                                "Magic: " & mag & vbCrLf & _
                                "Dexterity: " & dex & vbCrLf & _
                                "Vitality: " & vit & vbCrLf & _
                                "Gold: " & gold & vbCrLf
                              
    Case "SEXP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Starcraft: Broodwar" & vbCrLf & _
                                "Wins: " & scwins & vbCrLf & _
                                "Ladder: " & scladder & " (" & scrank & ")"
                               
    Case "W2BN"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Warcraft II: BNE" & vbCrLf & _
                                "Wins: " & wcwins & vbCrLf & _
                                "Ladder: " & wcladder
    Case "D2XP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
    Case "D2DV"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
End Select
For i = 1 To frmOptions.ListView1.ListItems.count
    If LCase(strAccount) = LCase(frmOptions.ListView1.ListItems(i).text) Then
        LastSeen = strAccount & " On " & Format(Date, "mm/dd/yy") & " at " & Format(Time, "hh:mm:ss")
        Exit For
    End If
Next i
LastUser = strAccount
End Sub

Private Sub Event_Join(strAccount As String, StrFlag, strText, Ping)
Dim Icon As Integer
Icon = GetIconCode(strText, StrFlag)
If Icon = ICON_GAVEL Then
    frmMain.RoomList.ListItems.add 1, , strAccount, , Icon
Else
    frmMain.RoomList.ListItems.add , , strAccount, , Icon
End If

If mbAlertLeaveJoin Then addText strAccount & " has joined the channel with a ping of " & Ping & " using ", vbCyan, strText & vbCrLf, vbWhite
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , , GetLagIcon(Ping, StrFlag)
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , Ping
Select Case ReverseString(Mid(strText, 1, 4))
    Case "DRTL"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Diablo Retail" & vbCrLf & _
                                "Level: " & lvl & vbCrLf & _
                                "Class: " & getClass(Val(chrClass)) & vbCrLf & _
                                "Dots: " & dots & vbCrLf & _
                                "Strength: " & strength & vbCrLf & _
                                "Magic: " & mag & vbCrLf & _
                                "Dexterity: " & dex & vbCrLf & _
                                "Vitality: " & vit & vbCrLf & _
                                "Gold: " & gold & vbCrLf
                                
    Case "SEXP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Starcraft: Broodwar" & vbCrLf & _
                                "Wins: " & scwins & vbCrLf & _
                                "Ladder: " & scladder & " (" & scrank & ")"
    Case "W2BN"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Warcraft II: BNE" & vbCrLf & _
                                "Wins: " & wcwins & vbCrLf & _
                                "Ladder: " & wcladder
    Case "D2XP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
    Case "D2DV"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
End Select
For i = 1 To frmOptions.ListView1.ListItems.count
    If LCase(strAccount) = LCase(frmOptions.ListView1.ListItems(i).text) Then
        LastSeen = strAccount & " On " & Format(Date, "mm/dd/yy") & " at " & Format(Time, "hh:mm:ss")
        Exit For
    End If
Next i
LastUser = strAccount
addText strAccount & " has joined the channel", ID_COLOR_INFO

If APIDeclares.OpsMode Then
    If Commands.CheckShitList(strAccount) Then
        Send "/ban " & strAccount & " ShitList", True
    End If
End If

End Sub

Private Sub Event_Leave(strUser As String, StrFlag)
On Error Resume Next
    Dim strCount As String
    
    strCount = frmMain.RoomList.ListItems.count
    If Err.Number = 0 Then
    frmMain.RoomList.ListItems.Remove frmMain.RoomList.FindItem(strUser).Index
    End If
   
    addText strUser & " has left the channel" & vbNewLine, ID_COLOR_INFO
    frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
    
End Sub

Private Sub Event_RecvWhisper(strUser As String, StrFlag, strText)
    addText "<From: " & strUser & "> ", ID_COLOR_NAMES, strText & vbCrLf, ID_COLOR_WHISPER
    DoCommands strUser, strText, True
End Sub

Private Sub Event_Talk(strUser As String, StrFlag, strText As String, Ping)
If Mid(LCase(strText), 1, 1) = "" Then
      addText "Decrypted From " & strUser & "in Hex: ", vbYellow, hexEncrypt(strText) & vbCrLf, vbWhite
Else
strText = ProfanityUnfilter(strText)
addText "<" & strUser & "> ", ID_COLOR_NAMES, strText & vbCrLf, vbWhite
'AddChat ID_COLOR_NAMES, "<", vbYellow, username, ID_COLOR_NAMES, "> ", vbWhite, strText
'CustomCommand strText, strUser
End If

If LCase(strText) = "?trigger" Then Send msTrigger & " (ALT + 0" & Asc(msTrigger) & ")", True
If Left(strText, 1) = msTrigger Then DoCommands strUser, strText, False

End Sub

Private Sub Event_Broadcast(strText As String)
   
    addText "Broadcast Message: " & strText & vbNewLine, ID_COLOR_INFO
End Sub

Private Sub Event_Channel(strUser, strText As String, Ping)
    frmMain.RoomList.ListItems.Clear
addText "Joining channel " & strText & vbCrLf, vbYellow
Dim i As Integer
Dim namelen As Integer
Dim found As Boolean
Dim listname As String
With frmChannels.Items
For i = 0 To .ListCount
        If .List(i) = "" Then
            found = False
            Exit For
        End If
        namelen = Len(.List(i))
        listname = .List(i)
        If namelen <> Len(strText) Then GoTo cont
        
        If strText = listname Then
            found = True
            Exit For
        End If
cont:
    Next i
    
If Not found Then
    .AddItem (strText)
End If
frmMain.Text1.text = strText & " " & frmMain.RoomList.ListItems.count
msChannelName = strText
username = strUser
End With
End Sub

Private Sub Event_Flags(strUser As String, StrFlag, statstring, Ping)
    Dim usrIndex As Integer
    
    usrIndex = frmMain.RoomList.FindItem(strUser).Index
    If statstring = "" Then statstring = "TAHC"
        With frmMain.RoomList
            .ListItems.Remove usrIndex
            .ListItems.add usrIndex, , strUser, , GetIconCode(statstring, StrFlag)
            .ListItems(.ListItems.count).ListSubItems.add , , , GetLagIcon(Ping, StrFlag)
            .ListItems(.ListItems.count).ListSubItems.add , , Ping
        End With
    If strUser = username Then
        APIDeclares.OpsMode = True
    End If
End Sub

Private Sub Event_SendWhisper(strUser As String, StrFlag, strText As String, Ping)
    
    If Not LCase(strUser) = LCase(username) Then
        addText "<To: " & strUser & "> ", ID_COLOR_NAMES, strText & vbCrLf, ID_COLOR_WHISPER
    End If
    
End Sub

Private Sub Event_Info(strText As String)
    AddChat vbCyan, ":", vbYellow, "Info", vbCyan, ": ", APIDeclares.ID_COLOR_BNETINFO, strText
End Sub

Private Sub Event_Error(strText As String)
    AddChat vbCyan, ":", vbYellow, "Error", vbCyan, ": ", vbRed, strText
End Sub

Public Function StrDump(hex As String) As String
    Dim i As Integer
    Dim s As String
    
    For i = 1 To Len(hex) Step 3
        s = Chr(Val("&h0" & Mid(hex, i, 2)))
        
        StrDump = StrDump & s
    Next
End Function

Public Function Word(strS As String, wordPick As Integer) As String
    On Error Resume Next
    Word = Split(strS, " ")(wordPick - 1)
End Function

