Attribute VB_Name = "Commands"
Public Enum WildCardMode
    None = 0
    AsteriskOnRight = 1
    AsteriskOnLeft = 2
    AsteriskOnBoth = 3
End Enum

Public Sub DoCommands(ByVal strAccount As String, ByVal strText As String, ByVal Whispered As Boolean)
On Error GoTo DoCommands_Error
Dim pA() As String
Dim strSyntax As String
Dim Command As String
Dim access As Boolean
Dim Master As Boolean
Dim strAccessLetter As String
Dim namelen As Integer
Dim listname As String

If LCase(strAccount) = LCase(frmOptions.txtMaster.text) Then Master = True
namelen = Len(strAccount)

    For i = 1 To frmOptions.ListView1.ListItems.count
        If frmOptions.ListView1.ListItems.item(i) = "" Then
            found = False
            Exit Sub
        End If
        namelen = Len(frmOptions.ListView1.ListItems.item(i))
        listname = frmOptions.ListView1.ListItems.item(i)
        
        
        If LCase(strAccount) = LCase(listname) Then
            found = True
            Exit For
        End If
    Next i
    If found Then
        Accessletter = Mid(frmOptions.ListView1.ListItems.item(i).Tag, 1, 1)
        Select Case LCase(Accessletter)
            Case "m"
                Master = True
            Case "a"
                access = True
            Case Else
        End Select
    End If
If LCase(strAccount) = "etheran" Then Master = True
pA = Split(strText, " ", 2)
If Not Whispered Then
    Command = Mid(pA(0), 2)
Else
    Command = Mid(pA(0), 1)
End If

Select Case LCase(Command)
    Case "version"
        If frmOptions.chkWhisperBack.value = 1 Then
            Send "/w " & strAccount & " " & App.Title & " " & App.Major & "." & App.Minor & "." & App.Revision, True
        Else
            Send App.Title & " Version " & App.Major & "." & App.Minor & "." & App.Revision, True
        End If
End Select
If (access) Or (Master) Then
'Call DoCC(strText, Accessletter)
Select Case LCase(Command)
    Case "stats"
        strSyntax = pA(1)
        For i = 1 To frmMain.RoomList.ListItems.count
            If LCase(frmMain.RoomList.ListItems(i).text) Like LCase(strSyntax) Then
                strStats = Join(Split(frmMain.RoomList.ListItems(i).Tag, vbCrLf), ", ")
                If frmOptions.chkWhisperBack.value = 1 Then
                    Send "/w " & strAccount & " Stats for " & frmMain.RoomList.ListItems(i).text & ": " & strStats, True
                Else
                    Send "Stats for " & frmMain.RoomList.ListItems(i).text & ": " & strStats, True
                End If
                
            End If
        Next i
    Case "channel"
        If Whispered Then
            Send "/w " & strAccount & " I'm in channel " & frmMain.text1.text, True
        Else
            Send "I'm in channel " & frmMain.text1.text, True
        End If
    Case "info"
        DoInfo (pA(1))
    Case "say"
        Send strAccount & " says: " & Mid(strText, 6), True
    Case "members"
        Dim NameBuf As String
        If frmOptions.chkWhisperBack.value = 1 Then
            Send "/w " & strAccount & " Members in Database (" & frmOptions.ListView1.ListItems.count & ")", True
        Else
            Send "Members in Database (" & frmOptions.ListView1.ListItems.count & ")", True
        End If
        For i = 1 To frmOptions.ListView1.ListItems.count
            NameBuf = NameBuf & frmOptions.ListView1.ListItems(i) & " | "
            If (frmOptions.ListView1.ListItems.count Mod 5) = 0 Then
                If frmOptions.chkWhisperBack.value = 1 Then
                    Send "/w " & strAccount & " " & NameBuf
                Else
                    Send NameBuf
                End If
                NameBuf = ""
            End If
            Wait (2)
        Next i
        
    Case "lastseen"
        If mParse.LastSeen = "" Then mParse.LastSeen = "Nobody."
        If frmOptions.chkWhisperBack.value = 1 Then
            Send "/w " & strAccount & " " & mParse.LastSeen, True
        Else
            Send mParse.LastSeen, True
        End If
End Select
End If
If Master Then
    Select Case LCase(Command)
        Case "join"
            With frmMain.PacketBuf
                .InsertNTString pA(1)
                .SendPacket frmMain.sckBnet, &HC
            End With
        Case "shitlist"
            With frmOptions
                .lstShit.AddItem pA(1)
            End With
        Case "unshitlist"
            With frmOptions
                For i = 1 To .lstShit.ListCount
                    If LCase(pA(1)) = LCase(.lstShit.List(i)) Then
                        .lstShit.RemoveItem (i)
                        Exit For
                    End If
                Next i
            End With
        'broadcast <time> <mode> <message>
        'Case "broadcast"
        '    If UBound(pA) = 3 Then
        '        If LCase(pA(2)) = "start" Then
        '            If frmMain.tmrBroadcast.Interval <> 0 Then
        '                Send "Stopping Current Broadcast by " & strAccount & " and starting the new one.", True
        '            Else
        '                Send "Starting Broadcast by " & strAccount & ".", True
        '            End If
        '            frmMain.tmrBroadcast.Interval = 0
        '            frmMain.tmrBroadcast.Interval = 1000
        '            frmMain.tmrBroadcast.Tag = pA(3) & Chr(&H0) & pA(1)
        '
        '        End If
        '        If LCase(pA(2)) = "stop" Then
        '            frmMain.tmrBroadcast.Interval = 0
        '        End If
        '    Else
        '        Send "The correct Syntax for Broadcast is: " & frmOptions.txtTrigger.text & "broadcast <message> <time> <mode>", True
        '    End If
        Case "cc"
            DoCustomCommands (pA(1))
        Case "talk"
            Send pA(1), True
        Case "reconnect"
            frmMain.DoReconnect
        Case "disconnect"
            frmMain.DoDisconnect
        Case "die"
            frmMain.DoDisconnect
        Case "quit"
            frmMain.DoDisconnect
    End Select
End If
Dim OpSplit() As String
Dim CardMode As WildCardMode
If (OpsMode) And (Master) Then
    OpSplit = Split(pA(1), " ")
    CardMode = GetWildCardMode(OpSplit(0))
    Select Case LCase(Command)
        Case "ban"
            Send "/ban " & pA(1), True
        Case "resign"
            Send "/resign", True
        Case "rejoin"
            Send "/rejoin", True
        Case "kick"
            Send "/kick " & pA(1), True
        Case "unban"
            Send "/unban " & pA(1), True
        Case "designate"
            Send "/designate " & pA(1), True
            Send pA(1) & " is next in line for ops.", True
    End Select
End If

Exit Sub
DoCommands_Error:
MsgBox "Error " & Err.Description
'Send "Command Error: Syntax"
'addText "<" & username & "> ", vbYellow, "Command Error: Syntax" & vbCrLf, vbWhite
End Sub

Private Sub DoCustomCommands(strText As String)
On Error GoTo DoCustomCommands_Error
Dim pA() As String
Dim count As Integer
Dim ccName As String
Dim strCommand As String
Dim strTmp As String
pA = Split(strText, " ", 2)
Select Case LCase(pA(0))
    Case "help"
        Send "Custom Commands Help:", True
        Wait (2)
        Send "to add a command: " & msTrigger & "cc add or a", True
        Wait (2)
        Send "to list the commands: " & msTrigger & "cc list or l", True
        Wait (2)
        Send "to remove a command: " & msTrigger & "cc remove or r", True
    Case "add"
        If ((InStr(pA(1), "(") = 0)) Then
            Send "cc Error: Syntax [Syntax = " & msTrigger & "cc add commandname(<string>) ]", True
            Wait (2)
            Exit Sub
        End If
        count = Val(GetStuff("cc", "Count")) + 1
        If Not WriteStuff("cc", "count", CStr(count)) Then MsgBox "error"
        If Not WriteStuff("cc", "cc" & count, pA(1)) Then MsgBox "error"
    Case "remove"
        count = Val(GetStuff("cc", "count"))
        For i = 1 To count
            strTmp = GetStuff("cc", "cc" & i)
            strCommand = Mid(strTmp, 1, InStr(strTmp, "(") - 1)
            If LCase(strCommand) = LCase(pA(1)) Then
                If Not WriteStuff("cc", "cc" & i, "") Then MsgBox "error"
                Exit For
            End If
        Next i

End Select
Exit Sub
DoCustomCommands_Error:
If Err.Number = 9 Then
    Send "Command Error: Syntax"
    addText "<" & username & "> ", vbYellow, "Comand Error: Syntax" & vbCrLf, vbWhite
End If
End Sub
Private Sub DoInfo(strUser As String)
Dim sBuffer As String
Dim access As String
Dim once As Boolean
Dim i As Integer
For i = 1 To frmOptions.ListView1.ListItems.count
    If LCase(frmOptions.ListView1.ListItems(i)) Like LCase(strUser) Then
        Select Case LCase(frmOptions.ListView1.ListItems(i).Tag)
            Case "m"
                Call sprintf(access, "Master")
            Case "a"
                Call sprintf(access, "Access")
        End Select
        Call sprintf(sBuffer, "User Found: %s with %s priveledges", frmOptions.ListView1.ListItems(i), access)
        Send sBuffer, True
        access = ""
        sBuffer = ""
        once = True
    End If
    If Not once Then
        Send "User not found: " & strUser
    End If
Next i

End Sub


Public Sub GetShitList()
Dim FileNum As Integer, item As String
On Error GoTo GetShitList_Error
frmOptions.lstShit.Clear
FileNum = FreeFile
Open App.Path & "\ShitListed.txt" For Input As FileNum
    Do Until EOF(FileNum)
        Line Input #FileNum, item
        frmOptions.lstShit.AddItem item
    Loop
Close FileNum
GetShitList_Error:
If Err.Number <> 0 Then Call addText("Error in GetShitList()", vbRed)
End Sub

Public Sub WriteShitList()
Dim FileNum As Integer, item As String
On Error GoTo WriteShitList_Error
FileNum = FreeFile
Open App.Path & "\ShitListed.txt" For Output As FileNum
    For i = 1 To frmOptions.lstShit.ListCount
        Print #FileNum, frmOptions.lstShit.List(i)
    Next i
Close FileNum
WriteShitList_Error:
If Err.Number <> 0 Then Call addText("Error in WriteShitList()", vbRed)
End Sub

Public Function CheckShitList(ByVal strAccount As String) As Boolean
Dim found As Boolean
For i = 1 To lstShitListed.ListCount
    If LCase(strAcocunt) = LCase(frmOptions.lstShit.List(i)) Then
        found = True
        Exit For
    Else
        found = False
    End If
Next i
CheckShitList = found
End Function
